package exercises.ex_d_bis;

public class StepThread extends Thread {
    private int i;
    private String startMsg;
    private String endMsg;
    private long duration;
    private Thread dependency;

    public StepThread(int i, String startMsg, String endMsg, long duration, Thread dependency) {
        this.i = i;
        this.startMsg = startMsg;
        this.endMsg = endMsg;
        this.duration = duration;
        this.dependency = dependency;
    }

    @Override
    public void run() {
        if (dependency != null) {
            try {
                dependency.join();
            } catch (InterruptedException e) {
                throw new RuntimeException(e);
            }
        }

        System.out.println("Stage " + i + ": " + startMsg);
        try {
            Thread.sleep(duration);
        } catch (InterruptedException e) {
            throw new RuntimeException(e);
        }
        System.out.println("Stage " + i + ": " + endMsg);
    }
}
