package exercises.ex_n;

import java.util.Stack;
import java.util.concurrent.locks.Lock;
import java.util.concurrent.locks.ReadWriteLock;
import java.util.concurrent.locks.ReentrantReadWriteLock;

public class NewsFeed {
    private final Stack<News> newsStack = new Stack<>();
    private final ReadWriteLock lock = new ReentrantReadWriteLock();
    private final Lock writeLock = lock.writeLock();
    private final Lock readLock = lock.readLock();

    public NewsFeed() {

    }

    public void put(News news) {
        try {
            writeLock.lock();
            newsStack.push(news);
        } finally {
            writeLock.unlock();
        }
    }

    public News read() {
        News news;
        try {
            readLock.lock();
            news = newsStack.peek();
        } finally {
            readLock.unlock();
        }
        return news;
    }
}
