package exercises.ex_p_bis;

import java.util.HashMap;
import java.util.Map;

public class ChristmasTree {
    private static final String[] lines = {
        "     ★       ★     ★",
        "       ★ ╱╲         ",
        "  ★     ╱  ╲   ★    ",
        "       ╱    ╲       ",
        "   ★  ╱      ╲    ★ ",
        "     ╱        ╲     ",
        "    ╱─        ─╲    ",
        "     ╱        ╲ ★   ",
        " ★  ╱          ╲    ",
        "   ╱────┐  ┌────╲   ",
        "    ★   │  │     ★  ",
    };
    public static final int W = 20;
    public static final int H = 11;
    private final Map<Integer, Light> lights = new HashMap<>();

    public void addLight(int x, int y, Light light) {
        lights.put(x + y * W, light);
        light.setTree(this);
    }

    public synchronized void show() {
        String result = "";
        for (int y=0; y < H; y++) {
            String line = "";
            for (int x=0; x < W; x++) {
                String c = String.valueOf(lines[y].charAt(x));
                if (c.equals("★")) {
                    c = Ansi.YELLOW + c + Ansi.RESET;
                }
                Light light = lights.get(x + y * W);
                if (light != null) {
                    c = light.apply(c);
                }
                line += c;
            }
            if (y != 0) {
                result += "\n";
            }
            result += line;
        }
        System.out.println(result);
    }
}
